import traceback

from cpl_core.configuration.configuration_model_abc import ConfigurationModelABC
from cpl_core.console import Console


class APISettings(ConfigurationModelABC):

    def __init__(self):
        ConfigurationModelABC.__init__(self)

        self._redirect_to_https = False

    @property
    def redirect_to_https(self) -> bool:
        return self._redirect_to_https

    def from_dict(self, settings: dict):
        try:
            self._redirect_to_https = bool(settings['RedirectToHTTPS'])
        except Exception as e:
            Console.error(f'[ ERROR ] [ {__name__} ]: Reading error in {type(self).__name__} settings')
            Console.error(f'[ EXCEPTION ] [ {__name__} ]: {e} -> {traceback.format_exc()}')
