import traceback

from cpl_core.console import Console

from bot_api.abc.dto_abc import DtoABC
from bot_api.model.version_dto import VersionDTO


class SettingsDTO(DtoABC):

    def __init__(
            self,
            web_version: str,
            api_version: VersionDTO,
            config_path: str,
            web_base_url: str,
            api_base_url: str,
            token_expire_time: int,
            refresh_token_expire_time: int,
            mail_user: str,
            mail_port: int,
            mail_host: str,
            mail_transceiver: str,
            mail_transceiver_address: str,
    ):
        DtoABC.__init__(self)

        self._web_version = ''
        self._api_version = VersionDTO()
        self._config_path = ''
        self._web_base_url = ''
        self._api_base_url = ''

        self._token_expire_time = 0
        self._refresh_token_expire_time = 0

        self._mail_user = ''
        self._mail_port = 0
        self._mail_host = ''
        self._mail_transceiver = ''
        self._mail_transceiver_address = ''

    def from_dict(self, values: dict):
        self._web_version = values['WebVersion']
        self._api_version.from_dict(values['ApiVersion'])
        self._config_path = values['ConfigPath']
        self._web_base_url = values['WebBaseURL']
        self._api_base_url = values['ApiBaseURL']
        self._token_expire_time = values['TokenExpireTime']
        self._refresh_token_expire_time = values['RefreshTokenExpireTime']
        self._mail_user = values['MailUser']
        self._mail_port = values['MailPort']
        self._mail_host = values['MailHost']
        self._mail_transceiver = values['MailTransceiver']
        self._mail_transceiver_address = values['MailTransceiverAddress']

    def to_dict(self) -> dict:
        return {
            'WebVersion': self._web_version,
            'ApiVersion': self._api_version.to_dict(),
            'ConfigPath': self._config_path,
            'WebBaseURL': self._web_base_url,
            'ApiBaseURL': self._api_base_url,
            'TokenExpireTime': self._token_expire_time,
            'RefreshTokenExpireTime': self._refresh_token_expire_time,
            'MailUser': self._mail_user,
            'MailPort': self._mail_port,
            'MailHost': self._mail_host,
            'MailTransceiver': self._mail_transceiver,
            'MailTransceiverAddress': self._mail_transceiver_address,
        }
